/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type Option, type OptionOrNullable, type ReadonlyAccount, type ReadonlySignerAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { type TokenStandardArgs } from '@tensor-foundation/resolvers';
import { TENSOR_AMM_PROGRAM_ADDRESS } from '../programs';
import { type AuthorizationDataLocal, type AuthorizationDataLocalArgs } from '../types';
export type BuyNftInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner extends string | IAccountMeta<string> = string, TAccountBuyer extends string | IAccountMeta<string> = string, TAccountRentPayer extends string | IAccountMeta<string> = string, TAccountFeeVault extends string | IAccountMeta<string> = string, TAccountPool extends string | IAccountMeta<string> = string, TAccountBuyerTa extends string | IAccountMeta<string> = string, TAccountPoolTa extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountNftReceipt extends string | IAccountMeta<string> = string, TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TAccountAssociatedTokenProgram extends string | IAccountMeta<string> = 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountEdition extends string | IAccountMeta<string> = string, TAccountPoolTokenRecord extends string | IAccountMeta<string> = string, TAccountBuyerTokenRecord extends string | IAccountMeta<string> = string, TAccountTokenMetadataProgram extends string | IAccountMeta<string> = string, TAccountSysvarInstructions extends string | IAccountMeta<string> = string, TAccountAuthorizationRulesProgram extends string | IAccountMeta<string> = string, TAccountAuthorizationRules extends string | IAccountMeta<string> = string, TAccountSharedEscrow extends string | IAccountMeta<string> = string, TAccountMakerBroker extends string | IAccountMeta<string> = string, TAccountTakerBroker extends string | IAccountMeta<string> = string, TAccountCosigner extends string | IAccountMeta<string> = string, TAccountAmmProgram extends string | IAccountMeta<string> = 'TAMMqgJYcquwwj2tCdNUerh4C2bJjmghijVziSEf5tA', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountOwner extends string ? ReadonlyAccount<TAccountOwner> : TAccountOwner,
    TAccountBuyer extends string ? WritableSignerAccount<TAccountBuyer> & IAccountSignerMeta<TAccountBuyer> : TAccountBuyer,
    TAccountRentPayer extends string ? WritableAccount<TAccountRentPayer> : TAccountRentPayer,
    TAccountFeeVault extends string ? WritableAccount<TAccountFeeVault> : TAccountFeeVault,
    TAccountPool extends string ? WritableAccount<TAccountPool> : TAccountPool,
    TAccountBuyerTa extends string ? WritableAccount<TAccountBuyerTa> : TAccountBuyerTa,
    TAccountPoolTa extends string ? WritableAccount<TAccountPoolTa> : TAccountPoolTa,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountNftReceipt extends string ? WritableAccount<TAccountNftReceipt> : TAccountNftReceipt,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    TAccountAssociatedTokenProgram extends string ? ReadonlyAccount<TAccountAssociatedTokenProgram> : TAccountAssociatedTokenProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountEdition extends string ? ReadonlyAccount<TAccountEdition> : TAccountEdition,
    TAccountPoolTokenRecord extends string ? WritableAccount<TAccountPoolTokenRecord> : TAccountPoolTokenRecord,
    TAccountBuyerTokenRecord extends string ? WritableAccount<TAccountBuyerTokenRecord> : TAccountBuyerTokenRecord,
    TAccountTokenMetadataProgram extends string ? ReadonlyAccount<TAccountTokenMetadataProgram> : TAccountTokenMetadataProgram,
    TAccountSysvarInstructions extends string ? ReadonlyAccount<TAccountSysvarInstructions> : TAccountSysvarInstructions,
    TAccountAuthorizationRulesProgram extends string ? ReadonlyAccount<TAccountAuthorizationRulesProgram> : TAccountAuthorizationRulesProgram,
    TAccountAuthorizationRules extends string ? ReadonlyAccount<TAccountAuthorizationRules> : TAccountAuthorizationRules,
    TAccountSharedEscrow extends string ? WritableAccount<TAccountSharedEscrow> : TAccountSharedEscrow,
    TAccountMakerBroker extends string ? WritableAccount<TAccountMakerBroker> : TAccountMakerBroker,
    TAccountTakerBroker extends string ? WritableAccount<TAccountTakerBroker> : TAccountTakerBroker,
    TAccountCosigner extends string ? ReadonlySignerAccount<TAccountCosigner> & IAccountSignerMeta<TAccountCosigner> : TAccountCosigner,
    TAccountAmmProgram extends string ? ReadonlyAccount<TAccountAmmProgram> : TAccountAmmProgram,
    ...TRemainingAccounts
]>;
export type BuyNftInstructionData = {
    discriminator: ReadonlyUint8Array;
    maxAmount: bigint;
    authorizationData: Option<AuthorizationDataLocal>;
    optionalRoyaltyPct: Option<number>;
};
export type BuyNftInstructionDataArgs = {
    maxAmount: number | bigint;
    authorizationData?: OptionOrNullable<AuthorizationDataLocalArgs>;
    optionalRoyaltyPct?: OptionOrNullable<number>;
};
export declare function getBuyNftInstructionDataEncoder(): Encoder<BuyNftInstructionDataArgs>;
export declare function getBuyNftInstructionDataDecoder(): Decoder<BuyNftInstructionData>;
export declare function getBuyNftInstructionDataCodec(): Codec<BuyNftInstructionDataArgs, BuyNftInstructionData>;
export type BuyNftInstructionExtraArgs = {
    tokenStandard?: TokenStandardArgs;
};
export type BuyNftAsyncInput<TAccountOwner extends string = string, TAccountBuyer extends string = string, TAccountRentPayer extends string = string, TAccountFeeVault extends string = string, TAccountPool extends string = string, TAccountBuyerTa extends string = string, TAccountPoolTa extends string = string, TAccountMint extends string = string, TAccountMetadata extends string = string, TAccountNftReceipt extends string = string, TAccountTokenProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountSystemProgram extends string = string, TAccountEdition extends string = string, TAccountPoolTokenRecord extends string = string, TAccountBuyerTokenRecord extends string = string, TAccountTokenMetadataProgram extends string = string, TAccountSysvarInstructions extends string = string, TAccountAuthorizationRulesProgram extends string = string, TAccountAuthorizationRules extends string = string, TAccountSharedEscrow extends string = string, TAccountMakerBroker extends string = string, TAccountTakerBroker extends string = string, TAccountCosigner extends string = string, TAccountAmmProgram extends string = string> = {
    /**
     * Owner is the pool owner who created the pool and the nominal owner of the
     * escrowed NFT. In this transaction they are the seller, though the transfer
     * of the NFT is handled by the pool.
     */
    owner: Address<TAccountOwner>;
    /** Buyer is the external signer who sends SOL to the pool to purchase the escrowed NFT. */
    buyer: TransactionSigner<TAccountBuyer>;
    /**
     * The original rent payer of the pool--stored on the pool. Used to refund rent in case the pool
     * is auto-closed.
     */
    rentPayer?: Address<TAccountRentPayer>;
    /** Fee vault account owned by the TFEE program. */
    feeVault?: Address<TAccountFeeVault>;
    /**
     * The Pool state account that holds the NFT to be purchased. Stores pool state and config,
     * but is also the owner of any NFTs in the pool, and also escrows any SOL.
     * Any active pool can be specified provided it is a Trade or NFT type.
     */
    pool: Address<TAccountPool>;
    /** The TA of the buyer, where the NFT will be transferred. */
    buyerTa?: Address<TAccountBuyerTa>;
    /** The TA of the pool, where the NFT is held. */
    poolTa?: Address<TAccountPoolTa>;
    /** The mint account of the NFT. */
    mint: Address<TAccountMint>;
    /** The Token Metadata metadata account of the NFT. */
    metadata?: Address<TAccountMetadata>;
    /** The NFT deposit receipt, which ties an NFT to the pool it was deposited to. */
    nftReceipt?: Address<TAccountNftReceipt>;
    /** The SPL Token program for the Mint and ATAs. */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** The SPL associated token program. */
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    /** The Token Metadata edition account for the NFT. */
    edition?: Address<TAccountEdition>;
    /** The Token Metadata token record for the pool. */
    poolTokenRecord?: Address<TAccountPoolTokenRecord>;
    /** The Token Metadata token record for the buyer. */
    buyerTokenRecord?: Address<TAccountBuyerTokenRecord>;
    /** The Token Metadata program account. */
    tokenMetadataProgram?: Address<TAccountTokenMetadataProgram>;
    /** The sysvar instructions account. */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
    /** The Metaplex Token Authority Rules program account. */
    authorizationRulesProgram?: Address<TAccountAuthorizationRulesProgram>;
    /** The Metaplex Token Authority Rules account that stores royalty enforcement rules. */
    authorizationRules?: Address<TAccountAuthorizationRules>;
    /** The shared escrow account for pools that pool liquidity in a shared account. */
    sharedEscrow?: Address<TAccountSharedEscrow>;
    /** The account that receives the maker broker fee. */
    makerBroker?: Address<TAccountMakerBroker>;
    /** The account that receives the taker broker fee. */
    takerBroker?: Address<TAccountTakerBroker>;
    /**
     * The optional cosigner account that must be passed in if the pool has a cosigner.
     * Checks are performed in the handler.
     */
    cosigner?: TransactionSigner<TAccountCosigner>;
    /** The AMM program account, used for self-cpi logging. */
    ammProgram?: Address<TAccountAmmProgram>;
    maxAmount: BuyNftInstructionDataArgs['maxAmount'];
    authorizationData?: BuyNftInstructionDataArgs['authorizationData'];
    optionalRoyaltyPct?: BuyNftInstructionDataArgs['optionalRoyaltyPct'];
    tokenStandard?: BuyNftInstructionExtraArgs['tokenStandard'];
    creators?: Array<Address>;
};
export declare function getBuyNftInstructionAsync<TAccountOwner extends string, TAccountBuyer extends string, TAccountRentPayer extends string, TAccountFeeVault extends string, TAccountPool extends string, TAccountBuyerTa extends string, TAccountPoolTa extends string, TAccountMint extends string, TAccountMetadata extends string, TAccountNftReceipt extends string, TAccountTokenProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountSystemProgram extends string, TAccountEdition extends string, TAccountPoolTokenRecord extends string, TAccountBuyerTokenRecord extends string, TAccountTokenMetadataProgram extends string, TAccountSysvarInstructions extends string, TAccountAuthorizationRulesProgram extends string, TAccountAuthorizationRules extends string, TAccountSharedEscrow extends string, TAccountMakerBroker extends string, TAccountTakerBroker extends string, TAccountCosigner extends string, TAccountAmmProgram extends string>(input: BuyNftAsyncInput<TAccountOwner, TAccountBuyer, TAccountRentPayer, TAccountFeeVault, TAccountPool, TAccountBuyerTa, TAccountPoolTa, TAccountMint, TAccountMetadata, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram, TAccountEdition, TAccountPoolTokenRecord, TAccountBuyerTokenRecord, TAccountTokenMetadataProgram, TAccountSysvarInstructions, TAccountAuthorizationRulesProgram, TAccountAuthorizationRules, TAccountSharedEscrow, TAccountMakerBroker, TAccountTakerBroker, TAccountCosigner, TAccountAmmProgram>): Promise<BuyNftInstruction<typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner, TAccountBuyer, TAccountRentPayer, TAccountFeeVault, TAccountPool, TAccountBuyerTa, TAccountPoolTa, TAccountMint, TAccountMetadata, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram, TAccountEdition, TAccountPoolTokenRecord, TAccountBuyerTokenRecord, TAccountTokenMetadataProgram, TAccountSysvarInstructions, TAccountAuthorizationRulesProgram, TAccountAuthorizationRules, TAccountSharedEscrow, TAccountMakerBroker, TAccountTakerBroker, TAccountCosigner, TAccountAmmProgram>>;
export type BuyNftInput<TAccountOwner extends string = string, TAccountBuyer extends string = string, TAccountRentPayer extends string = string, TAccountFeeVault extends string = string, TAccountPool extends string = string, TAccountBuyerTa extends string = string, TAccountPoolTa extends string = string, TAccountMint extends string = string, TAccountMetadata extends string = string, TAccountNftReceipt extends string = string, TAccountTokenProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountSystemProgram extends string = string, TAccountEdition extends string = string, TAccountPoolTokenRecord extends string = string, TAccountBuyerTokenRecord extends string = string, TAccountTokenMetadataProgram extends string = string, TAccountSysvarInstructions extends string = string, TAccountAuthorizationRulesProgram extends string = string, TAccountAuthorizationRules extends string = string, TAccountSharedEscrow extends string = string, TAccountMakerBroker extends string = string, TAccountTakerBroker extends string = string, TAccountCosigner extends string = string, TAccountAmmProgram extends string = string> = {
    /**
     * Owner is the pool owner who created the pool and the nominal owner of the
     * escrowed NFT. In this transaction they are the seller, though the transfer
     * of the NFT is handled by the pool.
     */
    owner: Address<TAccountOwner>;
    /** Buyer is the external signer who sends SOL to the pool to purchase the escrowed NFT. */
    buyer: TransactionSigner<TAccountBuyer>;
    /**
     * The original rent payer of the pool--stored on the pool. Used to refund rent in case the pool
     * is auto-closed.
     */
    rentPayer?: Address<TAccountRentPayer>;
    /** Fee vault account owned by the TFEE program. */
    feeVault: Address<TAccountFeeVault>;
    /**
     * The Pool state account that holds the NFT to be purchased. Stores pool state and config,
     * but is also the owner of any NFTs in the pool, and also escrows any SOL.
     * Any active pool can be specified provided it is a Trade or NFT type.
     */
    pool: Address<TAccountPool>;
    /** The TA of the buyer, where the NFT will be transferred. */
    buyerTa: Address<TAccountBuyerTa>;
    /** The TA of the pool, where the NFT is held. */
    poolTa: Address<TAccountPoolTa>;
    /** The mint account of the NFT. */
    mint: Address<TAccountMint>;
    /** The Token Metadata metadata account of the NFT. */
    metadata: Address<TAccountMetadata>;
    /** The NFT deposit receipt, which ties an NFT to the pool it was deposited to. */
    nftReceipt: Address<TAccountNftReceipt>;
    /** The SPL Token program for the Mint and ATAs. */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** The SPL associated token program. */
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    /** The Token Metadata edition account for the NFT. */
    edition: Address<TAccountEdition>;
    /** The Token Metadata token record for the pool. */
    poolTokenRecord?: Address<TAccountPoolTokenRecord>;
    /** The Token Metadata token record for the buyer. */
    buyerTokenRecord?: Address<TAccountBuyerTokenRecord>;
    /** The Token Metadata program account. */
    tokenMetadataProgram?: Address<TAccountTokenMetadataProgram>;
    /** The sysvar instructions account. */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
    /** The Metaplex Token Authority Rules program account. */
    authorizationRulesProgram?: Address<TAccountAuthorizationRulesProgram>;
    /** The Metaplex Token Authority Rules account that stores royalty enforcement rules. */
    authorizationRules?: Address<TAccountAuthorizationRules>;
    /** The shared escrow account for pools that pool liquidity in a shared account. */
    sharedEscrow?: Address<TAccountSharedEscrow>;
    /** The account that receives the maker broker fee. */
    makerBroker?: Address<TAccountMakerBroker>;
    /** The account that receives the taker broker fee. */
    takerBroker?: Address<TAccountTakerBroker>;
    /**
     * The optional cosigner account that must be passed in if the pool has a cosigner.
     * Checks are performed in the handler.
     */
    cosigner?: TransactionSigner<TAccountCosigner>;
    /** The AMM program account, used for self-cpi logging. */
    ammProgram?: Address<TAccountAmmProgram>;
    maxAmount: BuyNftInstructionDataArgs['maxAmount'];
    authorizationData?: BuyNftInstructionDataArgs['authorizationData'];
    optionalRoyaltyPct?: BuyNftInstructionDataArgs['optionalRoyaltyPct'];
    tokenStandard?: BuyNftInstructionExtraArgs['tokenStandard'];
    creators?: Array<Address>;
};
export declare function getBuyNftInstruction<TAccountOwner extends string, TAccountBuyer extends string, TAccountRentPayer extends string, TAccountFeeVault extends string, TAccountPool extends string, TAccountBuyerTa extends string, TAccountPoolTa extends string, TAccountMint extends string, TAccountMetadata extends string, TAccountNftReceipt extends string, TAccountTokenProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountSystemProgram extends string, TAccountEdition extends string, TAccountPoolTokenRecord extends string, TAccountBuyerTokenRecord extends string, TAccountTokenMetadataProgram extends string, TAccountSysvarInstructions extends string, TAccountAuthorizationRulesProgram extends string, TAccountAuthorizationRules extends string, TAccountSharedEscrow extends string, TAccountMakerBroker extends string, TAccountTakerBroker extends string, TAccountCosigner extends string, TAccountAmmProgram extends string>(input: BuyNftInput<TAccountOwner, TAccountBuyer, TAccountRentPayer, TAccountFeeVault, TAccountPool, TAccountBuyerTa, TAccountPoolTa, TAccountMint, TAccountMetadata, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram, TAccountEdition, TAccountPoolTokenRecord, TAccountBuyerTokenRecord, TAccountTokenMetadataProgram, TAccountSysvarInstructions, TAccountAuthorizationRulesProgram, TAccountAuthorizationRules, TAccountSharedEscrow, TAccountMakerBroker, TAccountTakerBroker, TAccountCosigner, TAccountAmmProgram>): BuyNftInstruction<typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner, TAccountBuyer, TAccountRentPayer, TAccountFeeVault, TAccountPool, TAccountBuyerTa, TAccountPoolTa, TAccountMint, TAccountMetadata, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram, TAccountEdition, TAccountPoolTokenRecord, TAccountBuyerTokenRecord, TAccountTokenMetadataProgram, TAccountSysvarInstructions, TAccountAuthorizationRulesProgram, TAccountAuthorizationRules, TAccountSharedEscrow, TAccountMakerBroker, TAccountTakerBroker, TAccountCosigner, TAccountAmmProgram>;
export type ParsedBuyNftInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /**
         * Owner is the pool owner who created the pool and the nominal owner of the
         * escrowed NFT. In this transaction they are the seller, though the transfer
         * of the NFT is handled by the pool.
         */
        owner: TAccountMetas[0];
        /** Buyer is the external signer who sends SOL to the pool to purchase the escrowed NFT. */
        buyer: TAccountMetas[1];
        /**
         * The original rent payer of the pool--stored on the pool. Used to refund rent in case the pool
         * is auto-closed.
         */
        rentPayer: TAccountMetas[2];
        /** Fee vault account owned by the TFEE program. */
        feeVault: TAccountMetas[3];
        /**
         * The Pool state account that holds the NFT to be purchased. Stores pool state and config,
         * but is also the owner of any NFTs in the pool, and also escrows any SOL.
         * Any active pool can be specified provided it is a Trade or NFT type.
         */
        pool: TAccountMetas[4];
        /** The TA of the buyer, where the NFT will be transferred. */
        buyerTa: TAccountMetas[5];
        /** The TA of the pool, where the NFT is held. */
        poolTa: TAccountMetas[6];
        /** The mint account of the NFT. */
        mint: TAccountMetas[7];
        /** The Token Metadata metadata account of the NFT. */
        metadata: TAccountMetas[8];
        /** The NFT deposit receipt, which ties an NFT to the pool it was deposited to. */
        nftReceipt: TAccountMetas[9];
        /** The SPL Token program for the Mint and ATAs. */
        tokenProgram: TAccountMetas[10];
        /** The SPL associated token program. */
        associatedTokenProgram: TAccountMetas[11];
        /** The Solana system program. */
        systemProgram: TAccountMetas[12];
        /** The Token Metadata edition account for the NFT. */
        edition: TAccountMetas[13];
        /** The Token Metadata token record for the pool. */
        poolTokenRecord?: TAccountMetas[14] | undefined;
        /** The Token Metadata token record for the buyer. */
        buyerTokenRecord?: TAccountMetas[15] | undefined;
        /** The Token Metadata program account. */
        tokenMetadataProgram?: TAccountMetas[16] | undefined;
        /** The sysvar instructions account. */
        sysvarInstructions?: TAccountMetas[17] | undefined;
        /** The Metaplex Token Authority Rules program account. */
        authorizationRulesProgram?: TAccountMetas[18] | undefined;
        /** The Metaplex Token Authority Rules account that stores royalty enforcement rules. */
        authorizationRules?: TAccountMetas[19] | undefined;
        /** The shared escrow account for pools that pool liquidity in a shared account. */
        sharedEscrow?: TAccountMetas[20] | undefined;
        /** The account that receives the maker broker fee. */
        makerBroker?: TAccountMetas[21] | undefined;
        /** The account that receives the taker broker fee. */
        takerBroker?: TAccountMetas[22] | undefined;
        /**
         * The optional cosigner account that must be passed in if the pool has a cosigner.
         * Checks are performed in the handler.
         */
        cosigner?: TAccountMetas[23] | undefined;
        /** The AMM program account, used for self-cpi logging. */
        ammProgram: TAccountMetas[24];
    };
    data: BuyNftInstructionData;
};
export declare function parseBuyNftInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedBuyNftInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=buyNft.d.ts.map