/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlyUint8Array, type WritableAccount } from '@solana/web3.js';
import { TENSOR_AMM_PROGRAM_ADDRESS } from '../programs';
export type CloseExpiredPoolInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountRentPayer extends string | IAccountMeta<string> = string, TAccountOwner extends string | IAccountMeta<string> = string, TAccountPool extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountRentPayer extends string ? WritableAccount<TAccountRentPayer> : TAccountRentPayer,
    TAccountOwner extends string ? WritableAccount<TAccountOwner> : TAccountOwner,
    TAccountPool extends string ? WritableAccount<TAccountPool> : TAccountPool,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type CloseExpiredPoolInstructionData = {
    discriminator: ReadonlyUint8Array;
};
export type CloseExpiredPoolInstructionDataArgs = {};
export declare function getCloseExpiredPoolInstructionDataEncoder(): Encoder<CloseExpiredPoolInstructionDataArgs>;
export declare function getCloseExpiredPoolInstructionDataDecoder(): Decoder<CloseExpiredPoolInstructionData>;
export declare function getCloseExpiredPoolInstructionDataCodec(): Codec<CloseExpiredPoolInstructionDataArgs, CloseExpiredPoolInstructionData>;
export type CloseExpiredPoolInput<TAccountRentPayer extends string = string, TAccountOwner extends string = string, TAccountPool extends string = string, TAccountSystemProgram extends string = string> = {
    /** The rent payer to refund pool rent to. */
    rentPayer?: Address<TAccountRentPayer>;
    /**
     * The owner account must be specified and match the account stored in the pool but does not have to sign
     * for expired pools.
     */
    owner: Address<TAccountOwner>;
    /** The pool to close. */
    pool: Address<TAccountPool>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
};
export declare function getCloseExpiredPoolInstruction<TAccountRentPayer extends string, TAccountOwner extends string, TAccountPool extends string, TAccountSystemProgram extends string>(input: CloseExpiredPoolInput<TAccountRentPayer, TAccountOwner, TAccountPool, TAccountSystemProgram>): CloseExpiredPoolInstruction<typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountRentPayer, TAccountOwner, TAccountPool, TAccountSystemProgram>;
export type ParsedCloseExpiredPoolInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The rent payer to refund pool rent to. */
        rentPayer: TAccountMetas[0];
        /**
         * The owner account must be specified and match the account stored in the pool but does not have to sign
         * for expired pools.
         */
        owner: TAccountMetas[1];
        /** The pool to close. */
        pool: TAccountMetas[2];
        /** The Solana system program. */
        systemProgram: TAccountMetas[3];
    };
    data: CloseExpiredPoolInstructionData;
};
export declare function parseCloseExpiredPoolInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedCloseExpiredPoolInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=closeExpiredPool.d.ts.map