/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type Option, type OptionOrNullable, type ReadonlyAccount, type ReadonlySignerAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_AMM_PROGRAM_ADDRESS } from '../programs';
import { type PoolConfig, type PoolConfigArgs } from '../types';
export type CreatePoolInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountRentPayer extends string | IAccountMeta<string> = string, TAccountOwner extends string | IAccountMeta<string> = string, TAccountPool extends string | IAccountMeta<string> = string, TAccountWhitelist extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountRentPayer extends string ? WritableSignerAccount<TAccountRentPayer> & IAccountSignerMeta<TAccountRentPayer> : TAccountRentPayer,
    TAccountOwner extends string ? ReadonlySignerAccount<TAccountOwner> & IAccountSignerMeta<TAccountOwner> : TAccountOwner,
    TAccountPool extends string ? WritableAccount<TAccountPool> : TAccountPool,
    TAccountWhitelist extends string ? ReadonlyAccount<TAccountWhitelist> : TAccountWhitelist,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type CreatePoolInstructionData = {
    discriminator: ReadonlyUint8Array;
    poolId: ReadonlyUint8Array;
    config: PoolConfig;
    currency: Option<Address>;
    sharedEscrow: Option<Address>;
    cosigner: Option<Address>;
    makerBroker: Option<Address>;
    orderType: number;
    maxTakerSellCount: Option<number>;
    expireInSec: Option<bigint>;
};
export type CreatePoolInstructionDataArgs = {
    poolId: ReadonlyUint8Array;
    config: PoolConfigArgs;
    currency?: OptionOrNullable<Address>;
    sharedEscrow?: OptionOrNullable<Address>;
    cosigner?: OptionOrNullable<Address>;
    makerBroker?: OptionOrNullable<Address>;
    orderType?: number;
    maxTakerSellCount?: OptionOrNullable<number>;
    expireInSec?: OptionOrNullable<number | bigint>;
};
export declare function getCreatePoolInstructionDataEncoder(): Encoder<CreatePoolInstructionDataArgs>;
export declare function getCreatePoolInstructionDataDecoder(): Decoder<CreatePoolInstructionData>;
export declare function getCreatePoolInstructionDataCodec(): Codec<CreatePoolInstructionDataArgs, CreatePoolInstructionData>;
export type CreatePoolAsyncInput<TAccountRentPayer extends string = string, TAccountOwner extends string = string, TAccountPool extends string = string, TAccountWhitelist extends string = string, TAccountSystemProgram extends string = string> = {
    /**
     * The account pay for the rent to open the pool. This will be stored on the pool
     * so it can be refunded when the pool is closed.
     */
    rentPayer?: TransactionSigner<TAccountRentPayer>;
    /** The owner of the pool will be stored and used to control permissioned pool instructions. */
    owner: TransactionSigner<TAccountOwner>;
    /** The pool state account. */
    pool?: Address<TAccountPool>;
    /** The whitelist that gatekeeps which NFTs can be bought or sold with this pool. */
    whitelist: Address<TAccountWhitelist>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    poolId?: CreatePoolInstructionDataArgs['poolId'];
    config: CreatePoolInstructionDataArgs['config'];
    currency?: CreatePoolInstructionDataArgs['currency'];
    sharedEscrow?: CreatePoolInstructionDataArgs['sharedEscrow'];
    cosigner?: CreatePoolInstructionDataArgs['cosigner'];
    makerBroker?: CreatePoolInstructionDataArgs['makerBroker'];
    orderType?: CreatePoolInstructionDataArgs['orderType'];
    maxTakerSellCount?: CreatePoolInstructionDataArgs['maxTakerSellCount'];
    expireInSec?: CreatePoolInstructionDataArgs['expireInSec'];
};
export declare function getCreatePoolInstructionAsync<TAccountRentPayer extends string, TAccountOwner extends string, TAccountPool extends string, TAccountWhitelist extends string, TAccountSystemProgram extends string>(input: CreatePoolAsyncInput<TAccountRentPayer, TAccountOwner, TAccountPool, TAccountWhitelist, TAccountSystemProgram>): Promise<CreatePoolInstruction<typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountRentPayer, TAccountOwner, TAccountPool, TAccountWhitelist, TAccountSystemProgram>>;
export type CreatePoolInput<TAccountRentPayer extends string = string, TAccountOwner extends string = string, TAccountPool extends string = string, TAccountWhitelist extends string = string, TAccountSystemProgram extends string = string> = {
    /**
     * The account pay for the rent to open the pool. This will be stored on the pool
     * so it can be refunded when the pool is closed.
     */
    rentPayer?: TransactionSigner<TAccountRentPayer>;
    /** The owner of the pool will be stored and used to control permissioned pool instructions. */
    owner: TransactionSigner<TAccountOwner>;
    /** The pool state account. */
    pool: Address<TAccountPool>;
    /** The whitelist that gatekeeps which NFTs can be bought or sold with this pool. */
    whitelist: Address<TAccountWhitelist>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    poolId?: CreatePoolInstructionDataArgs['poolId'];
    config: CreatePoolInstructionDataArgs['config'];
    currency?: CreatePoolInstructionDataArgs['currency'];
    sharedEscrow?: CreatePoolInstructionDataArgs['sharedEscrow'];
    cosigner?: CreatePoolInstructionDataArgs['cosigner'];
    makerBroker?: CreatePoolInstructionDataArgs['makerBroker'];
    orderType?: CreatePoolInstructionDataArgs['orderType'];
    maxTakerSellCount?: CreatePoolInstructionDataArgs['maxTakerSellCount'];
    expireInSec?: CreatePoolInstructionDataArgs['expireInSec'];
};
export declare function getCreatePoolInstruction<TAccountRentPayer extends string, TAccountOwner extends string, TAccountPool extends string, TAccountWhitelist extends string, TAccountSystemProgram extends string>(input: CreatePoolInput<TAccountRentPayer, TAccountOwner, TAccountPool, TAccountWhitelist, TAccountSystemProgram>): CreatePoolInstruction<typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountRentPayer, TAccountOwner, TAccountPool, TAccountWhitelist, TAccountSystemProgram>;
export type ParsedCreatePoolInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /**
         * The account pay for the rent to open the pool. This will be stored on the pool
         * so it can be refunded when the pool is closed.
         */
        rentPayer: TAccountMetas[0];
        /** The owner of the pool will be stored and used to control permissioned pool instructions. */
        owner: TAccountMetas[1];
        /** The pool state account. */
        pool: TAccountMetas[2];
        /** The whitelist that gatekeeps which NFTs can be bought or sold with this pool. */
        whitelist: TAccountMetas[3];
        /** The Solana system program. */
        systemProgram: TAccountMetas[4];
    };
    data: CreatePoolInstructionData;
};
export declare function parseCreatePoolInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedCreatePoolInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=createPool.d.ts.map