/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type Option, type OptionOrNullable, type ReadonlyAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { type TokenStandardArgs } from '@tensor-foundation/resolvers';
import { TENSOR_AMM_PROGRAM_ADDRESS } from '../programs';
import { type AuthorizationDataLocal, type AuthorizationDataLocalArgs } from '../types';
export type DepositNftInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner extends string | IAccountMeta<string> = string, TAccountPool extends string | IAccountMeta<string> = string, TAccountWhitelist extends string | IAccountMeta<string> = string, TAccountOwnerTa extends string | IAccountMeta<string> = string, TAccountPoolTa extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountNftReceipt extends string | IAccountMeta<string> = string, TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TAccountAssociatedTokenProgram extends string | IAccountMeta<string> = 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountMetadata extends string | IAccountMeta<string> = string, TAccountMintProof extends string | IAccountMeta<string> = string, TAccountEdition extends string | IAccountMeta<string> = string, TAccountOwnerTokenRecord extends string | IAccountMeta<string> = string, TAccountPoolTokenRecord extends string | IAccountMeta<string> = string, TAccountTokenMetadataProgram extends string | IAccountMeta<string> = string, TAccountSysvarInstructions extends string | IAccountMeta<string> = string, TAccountAuthorizationRules extends string | IAccountMeta<string> = string, TAccountAuthorizationRulesProgram extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountOwner extends string ? WritableSignerAccount<TAccountOwner> & IAccountSignerMeta<TAccountOwner> : TAccountOwner,
    TAccountPool extends string ? WritableAccount<TAccountPool> : TAccountPool,
    TAccountWhitelist extends string ? ReadonlyAccount<TAccountWhitelist> : TAccountWhitelist,
    TAccountOwnerTa extends string ? WritableAccount<TAccountOwnerTa> : TAccountOwnerTa,
    TAccountPoolTa extends string ? WritableAccount<TAccountPoolTa> : TAccountPoolTa,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountNftReceipt extends string ? WritableAccount<TAccountNftReceipt> : TAccountNftReceipt,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    TAccountAssociatedTokenProgram extends string ? ReadonlyAccount<TAccountAssociatedTokenProgram> : TAccountAssociatedTokenProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountMintProof extends string ? ReadonlyAccount<TAccountMintProof> : TAccountMintProof,
    TAccountEdition extends string ? ReadonlyAccount<TAccountEdition> : TAccountEdition,
    TAccountOwnerTokenRecord extends string ? WritableAccount<TAccountOwnerTokenRecord> : TAccountOwnerTokenRecord,
    TAccountPoolTokenRecord extends string ? WritableAccount<TAccountPoolTokenRecord> : TAccountPoolTokenRecord,
    TAccountTokenMetadataProgram extends string ? ReadonlyAccount<TAccountTokenMetadataProgram> : TAccountTokenMetadataProgram,
    TAccountSysvarInstructions extends string ? ReadonlyAccount<TAccountSysvarInstructions> : TAccountSysvarInstructions,
    TAccountAuthorizationRules extends string ? ReadonlyAccount<TAccountAuthorizationRules> : TAccountAuthorizationRules,
    TAccountAuthorizationRulesProgram extends string ? ReadonlyAccount<TAccountAuthorizationRulesProgram> : TAccountAuthorizationRulesProgram,
    ...TRemainingAccounts
]>;
export type DepositNftInstructionData = {
    discriminator: ReadonlyUint8Array;
    authorizationData: Option<AuthorizationDataLocal>;
};
export type DepositNftInstructionDataArgs = {
    authorizationData?: OptionOrNullable<AuthorizationDataLocalArgs>;
};
export declare function getDepositNftInstructionDataEncoder(): Encoder<DepositNftInstructionDataArgs>;
export declare function getDepositNftInstructionDataDecoder(): Decoder<DepositNftInstructionData>;
export declare function getDepositNftInstructionDataCodec(): Codec<DepositNftInstructionDataArgs, DepositNftInstructionData>;
export type DepositNftInstructionExtraArgs = {
    tokenStandard?: TokenStandardArgs;
};
export type DepositNftAsyncInput<TAccountOwner extends string = string, TAccountPool extends string = string, TAccountWhitelist extends string = string, TAccountOwnerTa extends string = string, TAccountPoolTa extends string = string, TAccountMint extends string = string, TAccountNftReceipt extends string = string, TAccountTokenProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountSystemProgram extends string = string, TAccountMetadata extends string = string, TAccountMintProof extends string = string, TAccountEdition extends string = string, TAccountOwnerTokenRecord extends string = string, TAccountPoolTokenRecord extends string = string, TAccountTokenMetadataProgram extends string = string, TAccountSysvarInstructions extends string = string, TAccountAuthorizationRules extends string = string, TAccountAuthorizationRulesProgram extends string = string> = {
    /** The owner of the pool and the NFT. */
    owner: TransactionSigner<TAccountOwner>;
    /** The pool to deposit the NFT into. */
    pool: Address<TAccountPool>;
    /** The whitelist that gatekeeps which NFTs can be deposited into the pool. Must match the whitelist stored in the pool state. */
    whitelist: Address<TAccountWhitelist>;
    /** The TA of the owner, where the NFT will be transferred from. */
    ownerTa?: Address<TAccountOwnerTa>;
    /** The TA of the pool, where the NFT will be escrowed. */
    poolTa?: Address<TAccountPoolTa>;
    /**
     * The mint account of the NFT. It should be the mint account common
     * to the owner_ta and pool_ta.
     */
    mint: Address<TAccountMint>;
    /** The NFT receipt account denoting that an NFT has been deposited into this pool. */
    nftReceipt?: Address<TAccountNftReceipt>;
    /** The SPL Token program for the Mint and ATAs. */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** The SPL associated token program. */
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    /** The Token Metadata metadata account of the NFT. */
    metadata?: Address<TAccountMetadata>;
    /** merkle proof condition in the whitelist. */
    mintProof?: Address<TAccountMintProof>;
    /** The Token Metadata edition account of the NFT. */
    edition?: Address<TAccountEdition>;
    /** The Token Metadata owner/buyer token record account of the NFT. */
    ownerTokenRecord?: Address<TAccountOwnerTokenRecord>;
    /** The Token Metadata pool token record account of the NFT. */
    poolTokenRecord?: Address<TAccountPoolTokenRecord>;
    /** The Token Metadata program account. */
    tokenMetadataProgram?: Address<TAccountTokenMetadataProgram>;
    /** The sysvar instructions account. */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
    /** The Metaplex Token Authority Rules account that stores royalty enforcement rules. */
    authorizationRules?: Address<TAccountAuthorizationRules>;
    /** The Metaplex Token Authority Rules program account. */
    authorizationRulesProgram?: Address<TAccountAuthorizationRulesProgram>;
    authorizationData?: DepositNftInstructionDataArgs['authorizationData'];
    tokenStandard?: DepositNftInstructionExtraArgs['tokenStandard'];
};
export declare function getDepositNftInstructionAsync<TAccountOwner extends string, TAccountPool extends string, TAccountWhitelist extends string, TAccountOwnerTa extends string, TAccountPoolTa extends string, TAccountMint extends string, TAccountNftReceipt extends string, TAccountTokenProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountSystemProgram extends string, TAccountMetadata extends string, TAccountMintProof extends string, TAccountEdition extends string, TAccountOwnerTokenRecord extends string, TAccountPoolTokenRecord extends string, TAccountTokenMetadataProgram extends string, TAccountSysvarInstructions extends string, TAccountAuthorizationRules extends string, TAccountAuthorizationRulesProgram extends string>(input: DepositNftAsyncInput<TAccountOwner, TAccountPool, TAccountWhitelist, TAccountOwnerTa, TAccountPoolTa, TAccountMint, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram, TAccountMetadata, TAccountMintProof, TAccountEdition, TAccountOwnerTokenRecord, TAccountPoolTokenRecord, TAccountTokenMetadataProgram, TAccountSysvarInstructions, TAccountAuthorizationRules, TAccountAuthorizationRulesProgram>): Promise<DepositNftInstruction<typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner, TAccountPool, TAccountWhitelist, TAccountOwnerTa, TAccountPoolTa, TAccountMint, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram, TAccountMetadata, TAccountMintProof, TAccountEdition, TAccountOwnerTokenRecord, TAccountPoolTokenRecord, TAccountTokenMetadataProgram, TAccountSysvarInstructions, TAccountAuthorizationRules, TAccountAuthorizationRulesProgram>>;
export type DepositNftInput<TAccountOwner extends string = string, TAccountPool extends string = string, TAccountWhitelist extends string = string, TAccountOwnerTa extends string = string, TAccountPoolTa extends string = string, TAccountMint extends string = string, TAccountNftReceipt extends string = string, TAccountTokenProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountSystemProgram extends string = string, TAccountMetadata extends string = string, TAccountMintProof extends string = string, TAccountEdition extends string = string, TAccountOwnerTokenRecord extends string = string, TAccountPoolTokenRecord extends string = string, TAccountTokenMetadataProgram extends string = string, TAccountSysvarInstructions extends string = string, TAccountAuthorizationRules extends string = string, TAccountAuthorizationRulesProgram extends string = string> = {
    /** The owner of the pool and the NFT. */
    owner: TransactionSigner<TAccountOwner>;
    /** The pool to deposit the NFT into. */
    pool: Address<TAccountPool>;
    /** The whitelist that gatekeeps which NFTs can be deposited into the pool. Must match the whitelist stored in the pool state. */
    whitelist: Address<TAccountWhitelist>;
    /** The TA of the owner, where the NFT will be transferred from. */
    ownerTa: Address<TAccountOwnerTa>;
    /** The TA of the pool, where the NFT will be escrowed. */
    poolTa: Address<TAccountPoolTa>;
    /**
     * The mint account of the NFT. It should be the mint account common
     * to the owner_ta and pool_ta.
     */
    mint: Address<TAccountMint>;
    /** The NFT receipt account denoting that an NFT has been deposited into this pool. */
    nftReceipt: Address<TAccountNftReceipt>;
    /** The SPL Token program for the Mint and ATAs. */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** The SPL associated token program. */
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    /** The Token Metadata metadata account of the NFT. */
    metadata: Address<TAccountMetadata>;
    /** merkle proof condition in the whitelist. */
    mintProof?: Address<TAccountMintProof>;
    /** The Token Metadata edition account of the NFT. */
    edition: Address<TAccountEdition>;
    /** The Token Metadata owner/buyer token record account of the NFT. */
    ownerTokenRecord?: Address<TAccountOwnerTokenRecord>;
    /** The Token Metadata pool token record account of the NFT. */
    poolTokenRecord?: Address<TAccountPoolTokenRecord>;
    /** The Token Metadata program account. */
    tokenMetadataProgram?: Address<TAccountTokenMetadataProgram>;
    /** The sysvar instructions account. */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
    /** The Metaplex Token Authority Rules account that stores royalty enforcement rules. */
    authorizationRules?: Address<TAccountAuthorizationRules>;
    /** The Metaplex Token Authority Rules program account. */
    authorizationRulesProgram?: Address<TAccountAuthorizationRulesProgram>;
    authorizationData?: DepositNftInstructionDataArgs['authorizationData'];
    tokenStandard?: DepositNftInstructionExtraArgs['tokenStandard'];
};
export declare function getDepositNftInstruction<TAccountOwner extends string, TAccountPool extends string, TAccountWhitelist extends string, TAccountOwnerTa extends string, TAccountPoolTa extends string, TAccountMint extends string, TAccountNftReceipt extends string, TAccountTokenProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountSystemProgram extends string, TAccountMetadata extends string, TAccountMintProof extends string, TAccountEdition extends string, TAccountOwnerTokenRecord extends string, TAccountPoolTokenRecord extends string, TAccountTokenMetadataProgram extends string, TAccountSysvarInstructions extends string, TAccountAuthorizationRules extends string, TAccountAuthorizationRulesProgram extends string>(input: DepositNftInput<TAccountOwner, TAccountPool, TAccountWhitelist, TAccountOwnerTa, TAccountPoolTa, TAccountMint, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram, TAccountMetadata, TAccountMintProof, TAccountEdition, TAccountOwnerTokenRecord, TAccountPoolTokenRecord, TAccountTokenMetadataProgram, TAccountSysvarInstructions, TAccountAuthorizationRules, TAccountAuthorizationRulesProgram>): DepositNftInstruction<typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner, TAccountPool, TAccountWhitelist, TAccountOwnerTa, TAccountPoolTa, TAccountMint, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram, TAccountMetadata, TAccountMintProof, TAccountEdition, TAccountOwnerTokenRecord, TAccountPoolTokenRecord, TAccountTokenMetadataProgram, TAccountSysvarInstructions, TAccountAuthorizationRules, TAccountAuthorizationRulesProgram>;
export type ParsedDepositNftInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The owner of the pool and the NFT. */
        owner: TAccountMetas[0];
        /** The pool to deposit the NFT into. */
        pool: TAccountMetas[1];
        /** The whitelist that gatekeeps which NFTs can be deposited into the pool. Must match the whitelist stored in the pool state. */
        whitelist: TAccountMetas[2];
        /** The TA of the owner, where the NFT will be transferred from. */
        ownerTa: TAccountMetas[3];
        /** The TA of the pool, where the NFT will be escrowed. */
        poolTa: TAccountMetas[4];
        /**
         * The mint account of the NFT. It should be the mint account common
         * to the owner_ta and pool_ta.
         */
        mint: TAccountMetas[5];
        /** The NFT receipt account denoting that an NFT has been deposited into this pool. */
        nftReceipt: TAccountMetas[6];
        /** The SPL Token program for the Mint and ATAs. */
        tokenProgram: TAccountMetas[7];
        /** The SPL associated token program. */
        associatedTokenProgram: TAccountMetas[8];
        /** The Solana system program. */
        systemProgram: TAccountMetas[9];
        /** The Token Metadata metadata account of the NFT. */
        metadata: TAccountMetas[10];
        /** merkle proof condition in the whitelist. */
        mintProof?: TAccountMetas[11] | undefined;
        /** The Token Metadata edition account of the NFT. */
        edition: TAccountMetas[12];
        /** The Token Metadata owner/buyer token record account of the NFT. */
        ownerTokenRecord?: TAccountMetas[13] | undefined;
        /** The Token Metadata pool token record account of the NFT. */
        poolTokenRecord?: TAccountMetas[14] | undefined;
        /** The Token Metadata program account. */
        tokenMetadataProgram?: TAccountMetas[15] | undefined;
        /** The sysvar instructions account. */
        sysvarInstructions?: TAccountMetas[16] | undefined;
        /** The Metaplex Token Authority Rules account that stores royalty enforcement rules. */
        authorizationRules?: TAccountMetas[17] | undefined;
        /** The Metaplex Token Authority Rules program account. */
        authorizationRulesProgram?: TAccountMetas[18] | undefined;
    };
    data: DepositNftInstructionData;
};
export declare function parseDepositNftInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedDepositNftInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=depositNft.d.ts.map