/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_AMM_PROGRAM_ADDRESS } from '../programs';
export type DepositNftT22Instruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner extends string | IAccountMeta<string> = string, TAccountPool extends string | IAccountMeta<string> = string, TAccountWhitelist extends string | IAccountMeta<string> = string, TAccountMintProof extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountOwnerTa extends string | IAccountMeta<string> = string, TAccountPoolTa extends string | IAccountMeta<string> = string, TAccountNftReceipt extends string | IAccountMeta<string> = string, TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TAccountAssociatedTokenProgram extends string | IAccountMeta<string> = 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountOwner extends string ? WritableSignerAccount<TAccountOwner> & IAccountSignerMeta<TAccountOwner> : TAccountOwner,
    TAccountPool extends string ? WritableAccount<TAccountPool> : TAccountPool,
    TAccountWhitelist extends string ? ReadonlyAccount<TAccountWhitelist> : TAccountWhitelist,
    TAccountMintProof extends string ? ReadonlyAccount<TAccountMintProof> : TAccountMintProof,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountOwnerTa extends string ? WritableAccount<TAccountOwnerTa> : TAccountOwnerTa,
    TAccountPoolTa extends string ? WritableAccount<TAccountPoolTa> : TAccountPoolTa,
    TAccountNftReceipt extends string ? WritableAccount<TAccountNftReceipt> : TAccountNftReceipt,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    TAccountAssociatedTokenProgram extends string ? ReadonlyAccount<TAccountAssociatedTokenProgram> : TAccountAssociatedTokenProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type DepositNftT22InstructionData = {
    discriminator: ReadonlyUint8Array;
};
export type DepositNftT22InstructionDataArgs = {};
export declare function getDepositNftT22InstructionDataEncoder(): Encoder<DepositNftT22InstructionDataArgs>;
export declare function getDepositNftT22InstructionDataDecoder(): Decoder<DepositNftT22InstructionData>;
export declare function getDepositNftT22InstructionDataCodec(): Codec<DepositNftT22InstructionDataArgs, DepositNftT22InstructionData>;
export type DepositNftT22AsyncInput<TAccountOwner extends string = string, TAccountPool extends string = string, TAccountWhitelist extends string = string, TAccountMintProof extends string = string, TAccountMint extends string = string, TAccountOwnerTa extends string = string, TAccountPoolTa extends string = string, TAccountNftReceipt extends string = string, TAccountTokenProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountSystemProgram extends string = string> = {
    /** The owner of the pool and the NFT. */
    owner: TransactionSigner<TAccountOwner>;
    /** The pool to deposit the NFT into. */
    pool: Address<TAccountPool>;
    /** The whitelist that gatekeeps which NFTs can be deposited into the pool. */
    whitelist: Address<TAccountWhitelist>;
    mintProof: Address<TAccountMintProof>;
    /**
     * The mint account of the NFT. It should be the mint account common
     * to the owner_ta and pool_ta.
     */
    mint: Address<TAccountMint>;
    /** The TA of the owner, where the NFT will be transferred from. */
    ownerTa?: Address<TAccountOwnerTa>;
    /** The TA of the pool, where the NFT will be escrowed. */
    poolTa?: Address<TAccountPoolTa>;
    /** The NFT receipt account denoting that an NFT has been deposited into this pool. */
    nftReceipt?: Address<TAccountNftReceipt>;
    /** The SPL Token program for the Mint and ATAs. */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** The SPL associated token program. */
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    creators: Array<Address>;
};
export declare function getDepositNftT22InstructionAsync<TAccountOwner extends string, TAccountPool extends string, TAccountWhitelist extends string, TAccountMintProof extends string, TAccountMint extends string, TAccountOwnerTa extends string, TAccountPoolTa extends string, TAccountNftReceipt extends string, TAccountTokenProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountSystemProgram extends string>(input: DepositNftT22AsyncInput<TAccountOwner, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountMint, TAccountOwnerTa, TAccountPoolTa, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram>): Promise<DepositNftT22Instruction<typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountMint, TAccountOwnerTa, TAccountPoolTa, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram>>;
export type DepositNftT22Input<TAccountOwner extends string = string, TAccountPool extends string = string, TAccountWhitelist extends string = string, TAccountMintProof extends string = string, TAccountMint extends string = string, TAccountOwnerTa extends string = string, TAccountPoolTa extends string = string, TAccountNftReceipt extends string = string, TAccountTokenProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountSystemProgram extends string = string> = {
    /** The owner of the pool and the NFT. */
    owner: TransactionSigner<TAccountOwner>;
    /** The pool to deposit the NFT into. */
    pool: Address<TAccountPool>;
    /** The whitelist that gatekeeps which NFTs can be deposited into the pool. */
    whitelist: Address<TAccountWhitelist>;
    mintProof: Address<TAccountMintProof>;
    /**
     * The mint account of the NFT. It should be the mint account common
     * to the owner_ta and pool_ta.
     */
    mint: Address<TAccountMint>;
    /** The TA of the owner, where the NFT will be transferred from. */
    ownerTa: Address<TAccountOwnerTa>;
    /** The TA of the pool, where the NFT will be escrowed. */
    poolTa: Address<TAccountPoolTa>;
    /** The NFT receipt account denoting that an NFT has been deposited into this pool. */
    nftReceipt: Address<TAccountNftReceipt>;
    /** The SPL Token program for the Mint and ATAs. */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** The SPL associated token program. */
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    creators: Array<Address>;
};
export declare function getDepositNftT22Instruction<TAccountOwner extends string, TAccountPool extends string, TAccountWhitelist extends string, TAccountMintProof extends string, TAccountMint extends string, TAccountOwnerTa extends string, TAccountPoolTa extends string, TAccountNftReceipt extends string, TAccountTokenProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountSystemProgram extends string>(input: DepositNftT22Input<TAccountOwner, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountMint, TAccountOwnerTa, TAccountPoolTa, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram>): DepositNftT22Instruction<typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner, TAccountPool, TAccountWhitelist, TAccountMintProof, TAccountMint, TAccountOwnerTa, TAccountPoolTa, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram>;
export type ParsedDepositNftT22Instruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The owner of the pool and the NFT. */
        owner: TAccountMetas[0];
        /** The pool to deposit the NFT into. */
        pool: TAccountMetas[1];
        /** The whitelist that gatekeeps which NFTs can be deposited into the pool. */
        whitelist: TAccountMetas[2];
        mintProof: TAccountMetas[3];
        /**
         * The mint account of the NFT. It should be the mint account common
         * to the owner_ta and pool_ta.
         */
        mint: TAccountMetas[4];
        /** The TA of the owner, where the NFT will be transferred from. */
        ownerTa: TAccountMetas[5];
        /** The TA of the pool, where the NFT will be escrowed. */
        poolTa: TAccountMetas[6];
        /** The NFT receipt account denoting that an NFT has been deposited into this pool. */
        nftReceipt: TAccountMetas[7];
        /** The SPL Token program for the Mint and ATAs. */
        tokenProgram: TAccountMetas[8];
        /** The SPL associated token program. */
        associatedTokenProgram: TAccountMetas[9];
        /** The Solana system program. */
        systemProgram: TAccountMetas[10];
    };
    data: DepositNftT22InstructionData;
};
export declare function parseDepositNftT22Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedDepositNftT22Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=depositNftT22.d.ts.map