/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type Option, type OptionOrNullable, type ReadonlyAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { type TokenStandardArgs } from '@tensor-foundation/resolvers';
import { TENSOR_AMM_PROGRAM_ADDRESS } from '../programs';
import { type AuthorizationDataLocal, type AuthorizationDataLocalArgs } from '../types';
export type WithdrawNftInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner extends string | IAccountMeta<string> = string, TAccountPool extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountOwnerTa extends string | IAccountMeta<string> = string, TAccountPoolTa extends string | IAccountMeta<string> = string, TAccountNftReceipt extends string | IAccountMeta<string> = string, TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TAccountAssociatedTokenProgram extends string | IAccountMeta<string> = 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountMetadata extends string | IAccountMeta<string> = string, TAccountEdition extends string | IAccountMeta<string> = string, TAccountOwnerTokenRecord extends string | IAccountMeta<string> = string, TAccountPoolTokenRecord extends string | IAccountMeta<string> = string, TAccountTokenMetadataProgram extends string | IAccountMeta<string> = string, TAccountSysvarInstructions extends string | IAccountMeta<string> = string, TAccountAuthorizationRules extends string | IAccountMeta<string> = string, TAccountAuthorizationRulesProgram extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountOwner extends string ? WritableSignerAccount<TAccountOwner> & IAccountSignerMeta<TAccountOwner> : TAccountOwner,
    TAccountPool extends string ? WritableAccount<TAccountPool> : TAccountPool,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountOwnerTa extends string ? WritableAccount<TAccountOwnerTa> : TAccountOwnerTa,
    TAccountPoolTa extends string ? WritableAccount<TAccountPoolTa> : TAccountPoolTa,
    TAccountNftReceipt extends string ? WritableAccount<TAccountNftReceipt> : TAccountNftReceipt,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    TAccountAssociatedTokenProgram extends string ? ReadonlyAccount<TAccountAssociatedTokenProgram> : TAccountAssociatedTokenProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountEdition extends string ? ReadonlyAccount<TAccountEdition> : TAccountEdition,
    TAccountOwnerTokenRecord extends string ? WritableAccount<TAccountOwnerTokenRecord> : TAccountOwnerTokenRecord,
    TAccountPoolTokenRecord extends string ? WritableAccount<TAccountPoolTokenRecord> : TAccountPoolTokenRecord,
    TAccountTokenMetadataProgram extends string ? ReadonlyAccount<TAccountTokenMetadataProgram> : TAccountTokenMetadataProgram,
    TAccountSysvarInstructions extends string ? ReadonlyAccount<TAccountSysvarInstructions> : TAccountSysvarInstructions,
    TAccountAuthorizationRules extends string ? ReadonlyAccount<TAccountAuthorizationRules> : TAccountAuthorizationRules,
    TAccountAuthorizationRulesProgram extends string ? ReadonlyAccount<TAccountAuthorizationRulesProgram> : TAccountAuthorizationRulesProgram,
    ...TRemainingAccounts
]>;
export type WithdrawNftInstructionData = {
    discriminator: ReadonlyUint8Array;
    authorizationData: Option<AuthorizationDataLocal>;
};
export type WithdrawNftInstructionDataArgs = {
    authorizationData?: OptionOrNullable<AuthorizationDataLocalArgs>;
};
export declare function getWithdrawNftInstructionDataEncoder(): Encoder<WithdrawNftInstructionDataArgs>;
export declare function getWithdrawNftInstructionDataDecoder(): Decoder<WithdrawNftInstructionData>;
export declare function getWithdrawNftInstructionDataCodec(): Codec<WithdrawNftInstructionDataArgs, WithdrawNftInstructionData>;
export type WithdrawNftInstructionExtraArgs = {
    tokenStandard?: TokenStandardArgs;
};
export type WithdrawNftAsyncInput<TAccountOwner extends string = string, TAccountPool extends string = string, TAccountMint extends string = string, TAccountOwnerTa extends string = string, TAccountPoolTa extends string = string, TAccountNftReceipt extends string = string, TAccountTokenProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountSystemProgram extends string = string, TAccountMetadata extends string = string, TAccountEdition extends string = string, TAccountOwnerTokenRecord extends string = string, TAccountPoolTokenRecord extends string = string, TAccountTokenMetadataProgram extends string = string, TAccountSysvarInstructions extends string = string, TAccountAuthorizationRules extends string = string, TAccountAuthorizationRulesProgram extends string = string> = {
    /** The owner of the pool and will receive the NFT at the owner_ta account. */
    owner: TransactionSigner<TAccountOwner>;
    /** The pool from which the NFT will be withdrawn. */
    pool: Address<TAccountPool>;
    /** The mint of the NFT. */
    mint: Address<TAccountMint>;
    /** The TA of the owner, where the NFT will be transferred to as a result of this action. */
    ownerTa?: Address<TAccountOwnerTa>;
    /** The TA of the pool, where the NFT token is escrowed. */
    poolTa?: Address<TAccountPoolTa>;
    /** The NFT deposit receipt, which ties an NFT to the pool it was deposited to. */
    nftReceipt?: Address<TAccountNftReceipt>;
    /** The SPL Token program for the Mint and ATAs. */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** The SPL associated token program. */
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    /** The Token Metadata metadata account of the NFT. */
    metadata?: Address<TAccountMetadata>;
    /** The Token Metadata edition of the NFT. */
    edition?: Address<TAccountEdition>;
    /** The Token Metadata owner's token record account of the NFT. */
    ownerTokenRecord?: Address<TAccountOwnerTokenRecord>;
    /** The Token Metadata token record for the pool. */
    poolTokenRecord?: Address<TAccountPoolTokenRecord>;
    /** The Token Metadata program account. */
    tokenMetadataProgram?: Address<TAccountTokenMetadataProgram>;
    /** The sysvar instructions account. */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
    /** The Metaplex Token Authority Rules account that stores royalty enforcement rules. */
    authorizationRules?: Address<TAccountAuthorizationRules>;
    /** The Metaplex Token Authority Rules program account. */
    authorizationRulesProgram?: Address<TAccountAuthorizationRulesProgram>;
    authorizationData?: WithdrawNftInstructionDataArgs['authorizationData'];
    tokenStandard?: WithdrawNftInstructionExtraArgs['tokenStandard'];
};
export declare function getWithdrawNftInstructionAsync<TAccountOwner extends string, TAccountPool extends string, TAccountMint extends string, TAccountOwnerTa extends string, TAccountPoolTa extends string, TAccountNftReceipt extends string, TAccountTokenProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountSystemProgram extends string, TAccountMetadata extends string, TAccountEdition extends string, TAccountOwnerTokenRecord extends string, TAccountPoolTokenRecord extends string, TAccountTokenMetadataProgram extends string, TAccountSysvarInstructions extends string, TAccountAuthorizationRules extends string, TAccountAuthorizationRulesProgram extends string>(input: WithdrawNftAsyncInput<TAccountOwner, TAccountPool, TAccountMint, TAccountOwnerTa, TAccountPoolTa, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram, TAccountMetadata, TAccountEdition, TAccountOwnerTokenRecord, TAccountPoolTokenRecord, TAccountTokenMetadataProgram, TAccountSysvarInstructions, TAccountAuthorizationRules, TAccountAuthorizationRulesProgram>): Promise<WithdrawNftInstruction<typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner, TAccountPool, TAccountMint, TAccountOwnerTa, TAccountPoolTa, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram, TAccountMetadata, TAccountEdition, TAccountOwnerTokenRecord, TAccountPoolTokenRecord, TAccountTokenMetadataProgram, TAccountSysvarInstructions, TAccountAuthorizationRules, TAccountAuthorizationRulesProgram>>;
export type WithdrawNftInput<TAccountOwner extends string = string, TAccountPool extends string = string, TAccountMint extends string = string, TAccountOwnerTa extends string = string, TAccountPoolTa extends string = string, TAccountNftReceipt extends string = string, TAccountTokenProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountSystemProgram extends string = string, TAccountMetadata extends string = string, TAccountEdition extends string = string, TAccountOwnerTokenRecord extends string = string, TAccountPoolTokenRecord extends string = string, TAccountTokenMetadataProgram extends string = string, TAccountSysvarInstructions extends string = string, TAccountAuthorizationRules extends string = string, TAccountAuthorizationRulesProgram extends string = string> = {
    /** The owner of the pool and will receive the NFT at the owner_ta account. */
    owner: TransactionSigner<TAccountOwner>;
    /** The pool from which the NFT will be withdrawn. */
    pool: Address<TAccountPool>;
    /** The mint of the NFT. */
    mint: Address<TAccountMint>;
    /** The TA of the owner, where the NFT will be transferred to as a result of this action. */
    ownerTa: Address<TAccountOwnerTa>;
    /** The TA of the pool, where the NFT token is escrowed. */
    poolTa: Address<TAccountPoolTa>;
    /** The NFT deposit receipt, which ties an NFT to the pool it was deposited to. */
    nftReceipt: Address<TAccountNftReceipt>;
    /** The SPL Token program for the Mint and ATAs. */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** The SPL associated token program. */
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
    /** The Token Metadata metadata account of the NFT. */
    metadata: Address<TAccountMetadata>;
    /** The Token Metadata edition of the NFT. */
    edition: Address<TAccountEdition>;
    /** The Token Metadata owner's token record account of the NFT. */
    ownerTokenRecord?: Address<TAccountOwnerTokenRecord>;
    /** The Token Metadata token record for the pool. */
    poolTokenRecord?: Address<TAccountPoolTokenRecord>;
    /** The Token Metadata program account. */
    tokenMetadataProgram?: Address<TAccountTokenMetadataProgram>;
    /** The sysvar instructions account. */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
    /** The Metaplex Token Authority Rules account that stores royalty enforcement rules. */
    authorizationRules?: Address<TAccountAuthorizationRules>;
    /** The Metaplex Token Authority Rules program account. */
    authorizationRulesProgram?: Address<TAccountAuthorizationRulesProgram>;
    authorizationData?: WithdrawNftInstructionDataArgs['authorizationData'];
    tokenStandard?: WithdrawNftInstructionExtraArgs['tokenStandard'];
};
export declare function getWithdrawNftInstruction<TAccountOwner extends string, TAccountPool extends string, TAccountMint extends string, TAccountOwnerTa extends string, TAccountPoolTa extends string, TAccountNftReceipt extends string, TAccountTokenProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountSystemProgram extends string, TAccountMetadata extends string, TAccountEdition extends string, TAccountOwnerTokenRecord extends string, TAccountPoolTokenRecord extends string, TAccountTokenMetadataProgram extends string, TAccountSysvarInstructions extends string, TAccountAuthorizationRules extends string, TAccountAuthorizationRulesProgram extends string>(input: WithdrawNftInput<TAccountOwner, TAccountPool, TAccountMint, TAccountOwnerTa, TAccountPoolTa, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram, TAccountMetadata, TAccountEdition, TAccountOwnerTokenRecord, TAccountPoolTokenRecord, TAccountTokenMetadataProgram, TAccountSysvarInstructions, TAccountAuthorizationRules, TAccountAuthorizationRulesProgram>): WithdrawNftInstruction<typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner, TAccountPool, TAccountMint, TAccountOwnerTa, TAccountPoolTa, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram, TAccountMetadata, TAccountEdition, TAccountOwnerTokenRecord, TAccountPoolTokenRecord, TAccountTokenMetadataProgram, TAccountSysvarInstructions, TAccountAuthorizationRules, TAccountAuthorizationRulesProgram>;
export type ParsedWithdrawNftInstruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The owner of the pool and will receive the NFT at the owner_ta account. */
        owner: TAccountMetas[0];
        /** The pool from which the NFT will be withdrawn. */
        pool: TAccountMetas[1];
        /** The mint of the NFT. */
        mint: TAccountMetas[2];
        /** The TA of the owner, where the NFT will be transferred to as a result of this action. */
        ownerTa: TAccountMetas[3];
        /** The TA of the pool, where the NFT token is escrowed. */
        poolTa: TAccountMetas[4];
        /** The NFT deposit receipt, which ties an NFT to the pool it was deposited to. */
        nftReceipt: TAccountMetas[5];
        /** The SPL Token program for the Mint and ATAs. */
        tokenProgram: TAccountMetas[6];
        /** The SPL associated token program. */
        associatedTokenProgram: TAccountMetas[7];
        /** The Solana system program. */
        systemProgram: TAccountMetas[8];
        /** The Token Metadata metadata account of the NFT. */
        metadata: TAccountMetas[9];
        /** The Token Metadata edition of the NFT. */
        edition: TAccountMetas[10];
        /** The Token Metadata owner's token record account of the NFT. */
        ownerTokenRecord?: TAccountMetas[11] | undefined;
        /** The Token Metadata token record for the pool. */
        poolTokenRecord?: TAccountMetas[12] | undefined;
        /** The Token Metadata program account. */
        tokenMetadataProgram?: TAccountMetas[13] | undefined;
        /** The sysvar instructions account. */
        sysvarInstructions?: TAccountMetas[14] | undefined;
        /** The Metaplex Token Authority Rules account that stores royalty enforcement rules. */
        authorizationRules?: TAccountMetas[15] | undefined;
        /** The Metaplex Token Authority Rules program account. */
        authorizationRulesProgram?: TAccountMetas[16] | undefined;
    };
    data: WithdrawNftInstructionData;
};
export declare function parseWithdrawNftInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedWithdrawNftInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=withdrawNft.d.ts.map