/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type ReadonlyAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_AMM_PROGRAM_ADDRESS } from '../programs';
export type WithdrawNftT22Instruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner extends string | IAccountMeta<string> = string, TAccountPool extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountOwnerTa extends string | IAccountMeta<string> = string, TAccountPoolTa extends string | IAccountMeta<string> = string, TAccountNftReceipt extends string | IAccountMeta<string> = string, TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TAccountAssociatedTokenProgram extends string | IAccountMeta<string> = 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountOwner extends string ? WritableSignerAccount<TAccountOwner> & IAccountSignerMeta<TAccountOwner> : TAccountOwner,
    TAccountPool extends string ? WritableAccount<TAccountPool> : TAccountPool,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountOwnerTa extends string ? WritableAccount<TAccountOwnerTa> : TAccountOwnerTa,
    TAccountPoolTa extends string ? WritableAccount<TAccountPoolTa> : TAccountPoolTa,
    TAccountNftReceipt extends string ? WritableAccount<TAccountNftReceipt> : TAccountNftReceipt,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    TAccountAssociatedTokenProgram extends string ? ReadonlyAccount<TAccountAssociatedTokenProgram> : TAccountAssociatedTokenProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    ...TRemainingAccounts
]>;
export type WithdrawNftT22InstructionData = {
    discriminator: ReadonlyUint8Array;
};
export type WithdrawNftT22InstructionDataArgs = {};
export declare function getWithdrawNftT22InstructionDataEncoder(): Encoder<WithdrawNftT22InstructionDataArgs>;
export declare function getWithdrawNftT22InstructionDataDecoder(): Decoder<WithdrawNftT22InstructionData>;
export declare function getWithdrawNftT22InstructionDataCodec(): Codec<WithdrawNftT22InstructionDataArgs, WithdrawNftT22InstructionData>;
export type WithdrawNftT22AsyncInput<TAccountOwner extends string = string, TAccountPool extends string = string, TAccountMint extends string = string, TAccountOwnerTa extends string = string, TAccountPoolTa extends string = string, TAccountNftReceipt extends string = string, TAccountTokenProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountSystemProgram extends string = string> = {
    /** The owner of the pool--must sign to withdraw an NFT from the pool. */
    owner: TransactionSigner<TAccountOwner>;
    /** The pool holding the NFT. */
    pool: Address<TAccountPool>;
    /** The mint of the NFT. */
    mint: Address<TAccountMint>;
    /** The TA of the owner where the NFT will be withdrawn to. */
    ownerTa?: Address<TAccountOwnerTa>;
    /** The TA of the pool, where the NFT token is escrowed. */
    poolTa?: Address<TAccountPoolTa>;
    /** The NFT deposit receipt, which ties an NFT to the pool it was deposited to. */
    nftReceipt?: Address<TAccountNftReceipt>;
    /** The SPL Token program for the Mint and ATAs. */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** The SPL associated token program. */
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
};
export declare function getWithdrawNftT22InstructionAsync<TAccountOwner extends string, TAccountPool extends string, TAccountMint extends string, TAccountOwnerTa extends string, TAccountPoolTa extends string, TAccountNftReceipt extends string, TAccountTokenProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountSystemProgram extends string>(input: WithdrawNftT22AsyncInput<TAccountOwner, TAccountPool, TAccountMint, TAccountOwnerTa, TAccountPoolTa, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram>): Promise<WithdrawNftT22Instruction<typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner, TAccountPool, TAccountMint, TAccountOwnerTa, TAccountPoolTa, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram>>;
export type WithdrawNftT22Input<TAccountOwner extends string = string, TAccountPool extends string = string, TAccountMint extends string = string, TAccountOwnerTa extends string = string, TAccountPoolTa extends string = string, TAccountNftReceipt extends string = string, TAccountTokenProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountSystemProgram extends string = string> = {
    /** The owner of the pool--must sign to withdraw an NFT from the pool. */
    owner: TransactionSigner<TAccountOwner>;
    /** The pool holding the NFT. */
    pool: Address<TAccountPool>;
    /** The mint of the NFT. */
    mint: Address<TAccountMint>;
    /** The TA of the owner where the NFT will be withdrawn to. */
    ownerTa: Address<TAccountOwnerTa>;
    /** The TA of the pool, where the NFT token is escrowed. */
    poolTa: Address<TAccountPoolTa>;
    /** The NFT deposit receipt, which ties an NFT to the pool it was deposited to. */
    nftReceipt: Address<TAccountNftReceipt>;
    /** The SPL Token program for the Mint and ATAs. */
    tokenProgram?: Address<TAccountTokenProgram>;
    /** The SPL associated token program. */
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    /** The Solana system program. */
    systemProgram?: Address<TAccountSystemProgram>;
};
export declare function getWithdrawNftT22Instruction<TAccountOwner extends string, TAccountPool extends string, TAccountMint extends string, TAccountOwnerTa extends string, TAccountPoolTa extends string, TAccountNftReceipt extends string, TAccountTokenProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountSystemProgram extends string>(input: WithdrawNftT22Input<TAccountOwner, TAccountPool, TAccountMint, TAccountOwnerTa, TAccountPoolTa, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram>): WithdrawNftT22Instruction<typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountOwner, TAccountPool, TAccountMint, TAccountOwnerTa, TAccountPoolTa, TAccountNftReceipt, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountSystemProgram>;
export type ParsedWithdrawNftT22Instruction<TProgram extends string = typeof TENSOR_AMM_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** The owner of the pool--must sign to withdraw an NFT from the pool. */
        owner: TAccountMetas[0];
        /** The pool holding the NFT. */
        pool: TAccountMetas[1];
        /** The mint of the NFT. */
        mint: TAccountMetas[2];
        /** The TA of the owner where the NFT will be withdrawn to. */
        ownerTa: TAccountMetas[3];
        /** The TA of the pool, where the NFT token is escrowed. */
        poolTa: TAccountMetas[4];
        /** The NFT deposit receipt, which ties an NFT to the pool it was deposited to. */
        nftReceipt: TAccountMetas[5];
        /** The SPL Token program for the Mint and ATAs. */
        tokenProgram: TAccountMetas[6];
        /** The SPL associated token program. */
        associatedTokenProgram: TAccountMetas[7];
        /** The Solana system program. */
        systemProgram: TAccountMetas[8];
    };
    data: WithdrawNftT22InstructionData;
};
export declare function parseWithdrawNftT22Instruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedWithdrawNftT22Instruction<TProgram, TAccountMetas>;
//# sourceMappingURL=withdrawNftT22.d.ts.map